module.exports = {
  env: {
    browser: true,
    es6: true,
    node: true,
  },
  extends: [
    'plugin:@typescript-eslint/recommended',
  ],
  globals: {
    Atomics: 'readonly',
    SharedArrayBuffer: 'readonly',
  },
  parser: '@typescript-eslint/parser',
  parserOptions: {
    ecmaFeatures: {
      jsx: true,
    },
    ecmaVersion: 2018,
    project: './tsconfig.json',
    sourceType: 'module',
  },
  plugins: [
    '@typescript-eslint',
    'react',
  ],
  rules: {
    '@typescript-eslint/explicit-function-return-type': 'error',
    '@typescript-eslint/indent': [
      'warn', 2, {
      SwitchCase: 1,
    } ],
    '@typescript-eslint/no-unused-vars': [
      'error', {
        args: 'all',
        argsIgnorePattern: '^_',
        caughtErrors: 'all',
        vars: 'all',
    } ],
    indent: 'off',
    'no-unused-vars': 'off',
  },
};
